from controllers.ControllerTank import ControllerTank
from models.enums.EnumGameObjectDirection import EnumGameObjectDirection


class ControllerAdvancedEnemyTank(ControllerTank):
    # difference from mediator and proxy, inherit base class, but pretend to be inherited
    def __init__(self, controller_tank: ControllerTank):
        #super().__init__() #Fake inheritance
        self._controller_tank = controller_tank
        self._controller_tank.get_tank().tank_level += 1

    def get_tank(self):
        return self._controller_tank.get_tank()

    def update(self, delta_time: float):
        self._controller_tank.update(delta_time)

    def set_direction(self, direction: EnumGameObjectDirection):
        self._controller_tank.set_direction(direction)

    def fire(self):
        self._controller_tank.fire()


