from typing import List

from models.enums.EnumGameObjectType import EnumGameObjectType
from models.GameObject import GameObject
from views.components.ComponentBullet import ComponentBullet
from views.components.ComponentEnemy import ComponentEnemy
from views.components.ComponentGameObject import ComponentGameObject
from views.components.ComponentTank import ComponentTank


class FactoryGameObject:

    def create_component(self, game_object: GameObject) -> ComponentGameObject:
        obj_type = game_object.game_object_type
        if obj_type  == EnumGameObjectType.Player:
            result = ComponentTank(game_object)
        elif obj_type == EnumGameObjectType.Enemy or obj_type == EnumGameObjectType.EnemyAdvanced:
            result = ComponentEnemy(game_object)
        elif obj_type in [EnumGameObjectType.Bullet, EnumGameObjectType.BulletPlayer]:
            result = ComponentBullet(game_object)
        else:
            result = ComponentGameObject(game_object)
        return result
